import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class LeeArchivo{
	
	static int nodos[][];

	public static VRP leer(String nombreArchivo, int numV, float pena) {
		int tam=0;
		float capacidad=0;
		float penalizacion = pena;
		int maximo=0;
		int costoEntrega=0;
		try {
			File file = new File(nombreArchivo);
			FileReader fileReader = new FileReader(file);
			BufferedReader bufferedReader = new BufferedReader(fileReader);
			int done = 0;
			String line;
			String subLine;
			int index;
			while (done < 4) {
				line = bufferedReader.readLine();
				index = line.indexOf(':');
				if (index > 0){
					subLine = line.substring(0,index-1).trim();
					if (subLine.equalsIgnoreCase("DIMENSION")){
						subLine=line.substring(index+1).trim();
						tam = Integer.parseInt(subLine);
						done++;
					}else if (subLine.equalsIgnoreCase("CAPACITY")){
						subLine=line.substring(index+1).trim();
						capacidad = Integer.parseInt(subLine);
						done++;
					
					}else if (subLine.equalsIgnoreCase("MAX_TIME")){
						subLine=line.substring(index+1).trim();
						maximo = Integer.parseInt(subLine);
						done++;
					
					}else if (subLine.equalsIgnoreCase("DROP_TIME")){
						subLine=line.substring(index+1).trim();
						costoEntrega = Integer.parseInt(subLine);
						done++;
					}
				}
			}
			tam++;
			nodos = new int[tam][3];
			while (done < 5) {
				line = bufferedReader.readLine().trim();
				if (line.equalsIgnoreCase("NODE_SECTION")){
					done++;
				}
			}
			String[] split;
			done=0;
			int[] dato = new int[3];
			while (done < tam) {
				line = bufferedReader.readLine().trim();
				split = line.split("\\s+");
				dato[0]=Integer.parseInt(split[0]);
				dato[1]=Integer.parseInt(split[1]);
				dato[2]=Integer.parseInt(split[2]);
				nodos[done][1]=dato[0];
				nodos[done][2]=dato[1];
				nodos[done][0]=dato[2];
				done++;
			}
			fileReader.close();		
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
		float[] d = new float[tam-1];
		for (int i = 1; i< tam; ++i){
			d[i-1] = nodos[i][0];
		}
		float[][] f = new float[tam][tam];
		for (int i=0 ;i<tam;++i){
			f[i][i]=0;
			for (int j=i+1; j< tam; ++j){
				f[i][j]=calculaDistancia(nodos[i][1],nodos[i][2],nodos[j][1],nodos[j][2])+costoEntrega;
				f[j][i]=i==0?f[i][j]-costoEntrega:f[i][j];
			}
		}
		VRP ejemplar = new VRP(d,f,numV,capacidad, penalizacion, (double)maximo);
		return ejemplar;
	}
	
	public static float calculaDistancia(int x1, int y1, int x2, int y2){
		int a = (x2-x1)*(x2-x1);
		int b = (y2-y1)*(y2-y1);
		float c = (float)Math.sqrt(a + b);
		return c;
	}
	
	public static String coordenadas(int indice){
		String s="("+nodos[indice][1]+", "+nodos[indice][2]+")";
		return s;
	}
}