/**
*Clase que modela un ejemplar del CVRP
*@author Fernando Michel Tavera
*/
public class VRP{
	private int numClientes;
	private int numVehiculos;
	private float capacidad;
	private float penalizacion;
	private double pesoMax;
	private float[] demandas;
	private float[][] peso;

/**
*Constructor
*
*/
	public VRP(float[] d, float[][] f, float cap){
		numClientes = d.length;
		numVehiculos = numClientes;
		capacidad = cap;
		penalizacion = 0.0f;
		pesoMax = Integer.MAX_VALUE; //2*numClientes*f[0][1];
		demandas = d;
		peso = f;
	}
/**
*Constructor "extendido" que recibe valores de numero maximo de vehiculos, de penalizacion por vehiculo y de distancia maxima por ruta.
*
*/
	public VRP(float[] d, float[][] f, int m, float cap, float pena, double maximo){
		numClientes = d.length;
		numVehiculos = m>numClientes?numClientes:m;
		capacidad = cap;
		penalizacion = pena;
		pesoMax = maximo;
		demandas = d;
		peso = f;
	}
	
/**
*
*
*/
	public float distancia(int i, int j){
		return peso[i][j];
	}
/**
*
*
*/
	public float demanda(int i){
		return demandas[i];
	}
/**
*
*
*/
	public double distanciaMaxima(){
		return pesoMax;
	}
/**
*
*
*/
	public float capacidad(){
		return capacidad;
	}
/**
*
*
*/
	public float penalizacion(){
		return penalizacion;
	}
/**
*
*
*/
	public int numClientes(){
		return numClientes;
	}
/**
*
*
*/
	public int numVehiculos(){
		return numVehiculos;
	}
}